/*
 *  hnv_t_flow_data_strct.h
 *  HeteroNumberViewer
 *
 *  Created by Naoto Morikawa on 9/21/07.
 *  Copyright (C) 2007 Naoto Morikawa. All rights reserved.
 *
 *  2007-10-01 version 0.1 release
 */

#include <GLUT/glut.h>


struct tetra_vertex {
	GLfloat coor[3];
};

struct tetra_tile {
	struct tetra_vertex normals[4];  // normal of vertices[i]
	struct tetra_vertex vertices[4];
	struct tetra_vertex  direction_vector;	// unit vector parallel to vector v3-v0
	float direction_vector_length;	// length of vector v3-v0
	HNV_GRADIENT gradient;		// xyz, xyw, xzw, yzw
	HNV_TETRA_CLASS belongs_to;	// class: IN, BD, OUT, UNKNOWN (unused)
	int direction;		// HNV_UP (= +1), HNV_DOWN (= -1), or 0
	int nearby_peak;
	HNV_TETRA_CHIRAL chiral;
};

struct tetra_seq {
	int length;
	HNV_TRAJ_TYPE type;	// CLOSED, NOT_CLOSED, UNKNOWN
	struct tetra_tile * tiles;
};

struct tetra_peak {
	HNV_PEAK_TYPE redundance;
	GLfloat coor3d[3];
	GLfloat coor4d[4];
};

// t_flow->sequences[i]->tiles[j]->vertex[k].coor[l]
struct tetra_flow {
	int seq_ct;
	struct tetra_seq * sequences;
	int std_cone_peak_ct;
	int std_cone_peak_size;
	struct tetra_peak * std_cone;
	int std_roof_peak_ct;
	int std_roof_peak_size;
	struct tetra_peak * std_roof;
	int conj_roof_peak_ct;
	int conj_roof_peak_size;
	struct tetra_peak * conj_roof;
};
